'
'SI5351 50MHz AM VFO_10    2021.12.17    JE1UCI
'------------------------------------------------------------------------------
$regfile = "attiny861.dat"
$crystal = 2000000                                          'kbc̕\x̂Ō

$hwstack = 32
$swstack = 4
$framesize = 16


Config Porta = &B11110011                                   '0=INPUT   1=OUTPUT
Config Portb = &B00000000                                   '0=INPUT   1=OUTPUT
Porta = &B00001100
Portb = &B00001111


Config Adc = Single , Prescaler = Auto , Reference = Avcc

Config Scl = Porta.1
Config Sda = Porta.0

Config I2cdelay = 5

Dim Frq As Long
Dim Start_frq As Long
Dim Max_frq As Long
Dim Min_frq As Long
Dim Tempa As Byte
Dim Tempb As Byte
Dim Tempc As Byte
Dim Tempd As Long
Dim Tempe As Long
Dim Tempf As Single
Dim Tempg As Long
Dim Rena_flag As Byte
Dim Renb_flag As Byte
Dim Osc As Single

Dim Frqdata As String * 8
Dim Flaga As Byte
Dim Flagb As Byte

Dim Reg As Byte
Dim Dat As Byte

Dim Ap1 As Word
Dim Ap2 As Long
Dim Ap3 As Long

Dim Reg26 As Byte
Dim Reg27 As Byte
Dim Reg28 As Byte

Dim Reg29a As Byte
Dim Reg29 As Byte
Dim Reg29b As Byte

Dim Reg30 As Byte
Dim Reg31 As Byte
Dim Reg32 As Byte
Dim Reg33 As Byte

Declare Sub G_i2cwrite(byval D As Byte)
Dim A As String * 9


   Start_frq = 50650000                                     'dnm̎g
   Max_frq = 51000000                                       'őg
   Min_frq = 50000000                                       'ŏg
'------------------------------------------------------------------------------
Dataset:
   Frq = Start_frq


   I2cinit

   Waitms 500
   Gosub Si5351_set
   Gosub Si5351_frq
   Gosub Si5351


   Cls
   Waitms 500


   Gosub Aqm0802_set



'------------------------------------------------------------------------------
Main:

If Pinb.4 = 1 Then
   Goto Main_rena1
      End If



Main_rena:
   Gosub Rena
       Select Case Rena_flag
          Case 1 : Goto Main_dn
          Case 2 : Goto Main_up
          Case Else : Goto Main_end
               End Select
Main_up:
   Rena_flag = 0
   Tempa = 100
   Frq = Frq + Tempa
   Gosub Maxchk
   Goto Main_lcd
Main_dn:
   Rena_flag = 0
   Tempa = 100
   Frq = Frq - Tempa
   Gosub Minchk
   Goto Main_lcd





Main_rena1:
   Gosub Rena
       Select Case Rena_flag
          Case 1 : Goto Main_dn1k
          Case 2 : Goto Main_up1k
          Case Else : Goto Main_end
               End Select

Main_up1k:
   Rena_flag = 0
   Tempd = 1000
   Frq = Frq + Tempd
   Gosub Maxchk
   Goto Main_lcd
Main_dn1k:
   Rena_flag = 0
   Tempd = 1000
   Frq = Frq - Tempd
   Gosub Minchk
   Goto Main_lcd

Main_lcd:
   Gosub Dspfrq
Main_si5351:
   Gosub Si5351_frq


   Gosub Si5351
Main_end:
   Goto Main
   End
'------------------------------------------------------------------------------
'ȉTu[`
'------------------------------------------------------------------------------
Rena:
   Tempa = Pina
        Tempa = Tempa And &H0C
   Select Case Flaga
      Case &H00 : Goto Rena_0
      Case &H04 : Goto Rena_1
      Case &H08 : Goto Rena_2
      Case &H0C : Goto Rena_3
      Case Else : Goto Rena_end
         End Select
Rena_0:
   Select Case Tempa
      Case &H00 : Goto Rena_end
      Case &H04 : Goto Rena_up
      Case &H08 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select
Rena_1:
   Select Case Tempa
      Case &H04 : Goto Rena_end
      Case &H0C : Goto Rena_up
      Case &H00 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select
Rena_2:
    Select Case Tempa
      Case &H08 : Goto Rena_end
      Case &H00 : Goto Rena_up
      Case &H0C : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select
Rena_3:
   Select Case Tempa
      Case &H0C : Goto Rena_end
      Case &H08 : Goto Rena_up
      Case &H04 : Goto Rena_dn
      Case Else : Goto Rena_end
         End Select
Rena_up:
   Rena_flag = 1
   Goto Rena_end
Rena_dn:
   Rena_flag = 2
Rena_end:
   Flaga = Tempa


   Locate 2 , 1
   Lcd Rena_flag

   Lcd " "

   Return
'------------------------------------------------------------------------------

'------------------------------------------------------------------------------
Si5351_frq:
   Tempe = Frq - 49999200                                   '50000000{̒lł邪̂ߕύX

   Tempe = Tempe / 100
   Tempe = Tempe * 48
   Tempe = Tempe * 128
   Tempf = Tempe / 1000000
   Tempf = Int(tempf)

   Ap1 = Tempf + 2560
   Tempg = Tempf * 1000000

   Ap2 = Tempe - Tempg

   Ap3 = 1000000



   Locate 1 , 1
   Lcd "                "
   Locate 1 , 1
   Lcd Ap1

   Locate 1 , 8
   Lcd Ap2



   Reg27 = Low(ap3)
   Shift Ap3 , Right , 8

   Reg26 = Low(ap3)

   Reg30 = Low(ap1)

   Shift Ap1 , Right , 8
   Reg29 = Low(ap1)


   Shift Ap1 , Right , 8
   Reg28 = Low(ap1)


   Reg33 = Low(ap2)

   Shift Ap2 , Right , 8
   Reg32 = Low(ap2)

   Shift Ap2 , Right , 8
   Reg31 = Low(ap2)
   Shift Ap3 , Right , 8
   Shift Ap3 , Left , 4
   Reg31 = Reg31 Or Ap3

   Return
'------------------------------------------------------------------------------
Si5351:
   Reg = 26                                                 'MSNA_P3 (15:8)
   Dat = Reg26
   Gosub Si5351_send
   Reg = 27                                                 'MSNA_P3 (7:0)
   Dat = Reg27
   Gosub Si5351_send


   Reg = 28                                                 'MSNA_P1 (17:16)
   Dat = Reg28
   Gosub Si5351_send
   Reg = 29                                                 'MSNA_P1 (15:8)
   Dat = Reg29
   Gosub Si5351_send
   Reg = 30                                                 'MSNA_P1 (7:0)
   Dat = Reg30
   Gosub Si5351_send


   Reg = 31                                                 'MSNA_P3 (19:16) MSNA_P2 (19:16)
   Dat = Reg31
   Gosub Si5351_send


   Reg = 32                                                 'MSNA_P2 (15:8)
   Dat = Reg32
   Gosub Si5351_send
   Reg = 33                                                 'MSNA_P2 (7:0)
   Dat = Reg33
   Gosub Si5351_send





   Reg = 42                                                 'MS0_P3 (15:8)
   Dat = &H00
   Gosub Si5351_send
   Reg = 43                                                 'MS0_P3 (7:0)
   Dat = &H01
   Gosub Si5351_send

   Reg = 44                                                 'MS0_P1 (17:16)
   Dat = &H00
   Gosub Si5351_send
   Reg = 45                                                 'MS0_P1 (15:8)
   Dat = &H04
   Gosub Si5351_send
   Reg = 46                                                 'MS0_P1 (7:0)
   Dat = &H00
   Gosub Si5351_send


   Reg = 47                                                 'MS0_P3 (19:16)   MS0_P2 (19:16)
   Dat = &H00
   Gosub Si5351_send


   Reg = 48                                                 'MS0_P2 (15:8)
   Dat = &H00
   Gosub Si5351_send
   Reg = 49                                                 'MS0_P2 (7:0)
   Dat = &H00
   Gosub Si5351_send

   Reg = 177
   Dat = &HA0
   Reg = 16
   Dat = &H4F
   Reg = 3
   Dat = &HFE

   Return

'------------------------------------------------------------------------------
Si5351_set:
   Reg = 3
   Dat = &HFE
   Gosub Si5351_send
   Reg = 16
   Dat = &H4F
   Gosub Si5351_send
   Reg = 17
   Dat = &H80
   Gosub Si5351_send
   Reg = 18
   Dat = &H80
   Gosub Si5351_send

   Reg = 177
   Dat = &HA0
   Gosub Si5351_send

   Reg = 183
   Dat = &H80
   Gosub Si5351_send

   Return

'-----------------------
Si5351_send:
   I2cstart

   I2cwbyte &HC0
   Waitus 1
   I2cwbyte Reg
   Waitus 1
   I2cwbyte Dat

   I2cstop
   Return



'------------------------------------------------------------------------------
Aqm0802_set:

'I2cinit
'Waitms 40
Call G_i2cwrite(&H38)
Waitus 27
Call G_i2cwrite(&H39)
Waitus 27
Call G_i2cwrite(&H14)
Waitus 27
Call G_i2cwrite(&H70)
Waitus 27
Call G_i2cwrite(&H56)
Waitus 27
Call G_i2cwrite(&H6c)
Waitus 27
Call G_i2cwrite(&H38)
Waitus 27
Call G_i2cwrite(&H0c)
Waitus 27
Call G_i2cwrite(&H01)

Waitms 2

'  "A = "@4506500 "

A = "@" + Str(frq)

Call G_i2cwrite(&H80)
I2csend &H7C , A , 9


A = "@MHz"
Call G_i2cwrite(&Hc5)



I2csend &H7C , A , 9




   I2cstop

Return

'------------------------------------------------------------------------------
Dspfrq:
A = "@" + Str(frq)

Call G_i2cwrite(&H80)
I2csend &H7C , A , 9


A = "@MHz"
Call G_i2cwrite(&Hc5)



I2csend &H7C , A , 9




   I2cstop

Return










'-----------------------
Sub G_i2cwrite(byval D As Byte)
I2cstart
I2cwbyte &H7C
I2cwbyte &H80
I2cwbyte D
I2cstop
End Sub





'------------------------------------------------------------------------------
Minchk:
   If Frq < Min_frq Then
     Frq = Min_frq
        End If
   Return
'------------------------------------------------------------------------------
Maxchk:
   If Frq > Max_frq Then
   Frq = Max_frq
     End If
   Return
'------------------------------------------------------------------------------
   End